FORENV  PROC
C
      IMPLICIT  INTEGER (A-Z)      @ STANDARD FOR FORTRAN ELEMENTS.
          PARAMETER JPL = 0,LMSC = 1
C
C         GLOBAL BIT-FIELD DEFINITIONS.
C
      DEFINE  H1(I) = FLD(0,18,I)
      DEFINE  H2(I) = FLD(18,18,I)
      DEFINE  T1(I) = FLD(0,12,I)
      DEFINE  T2(I) = FLD(12,12,I)
      DEFINE  T3(I) = FLD(24,12,I)
      DEFINE  S1(I) = FLD(0,6,I)
      DEFINE  S2(I) = FLD(6,6,I)
      DEFINE  S3(I) = FLD(12,6,I)
      DEFINE  S4(I) = FLD(18,6,I)
      DEFINE  S5(I) = FLD(24,6,I)
      DEFINE  S6(I) = FLD(30,6,I)
 END
EXOTIC  PROC
C
C         ABSOLUTE ADDRESSING MECHANISM.  IF X IS AN ADDRESS, CORE(X)
C         IS ITS CONTENTS.  REQUIRES BIT-FIELD DEFINITIONS.
C
      COMMON  /VDUMMY/ VDUMMY(1)             @ SAVE WASTE SPACE.
      DEFINE  WDUMMY(I) = VDUMMY(I)          @ ALLOW FUNCT REFS IN SUBSC
      DEFINE  CORE(I) = WDUMMY(H2(I)-LOC(VDUMMY(1))+1)
C
C         SUBSCR(V,A) --- FACILITATES LATER FORTRAN CONVERSION.
C         CONVERT ABSOLUTE ADDRESS A INTO SUBSCRIPT FOR VECTOR V:
C
        DEFINE SUBSCR(I,J)=H2(ABS(J))    -   LOC(I)   +1
 END
FORCR  PROC
C
C         COMMUNICATION REGION.  SEE LISTING OF N0MN FOR DEFNS/VALUES.
C
      COMMON  /CRRGZZ/  CRPAD,
     *    CRDUMP,CRC,CRCD,CRCDP,CRCRDT,CRCOMP,CRD,CRE
     * ,CREDP,CREP,CRFL,CRGSYM,LCN,CRISYM,CRLAB,CRLIST
     * ,CRME,CRMLEV,N0LOGF,CRFLGS,CRNEXD,TSYM,CRPRO
     * ,CRALC,CRRELN,RPFLG$,CREFCT,CRDGSY,BRKPTT,CRSTC1,CRSTC2
     * ,CRSTC3,CRSTC5,CRSTC6,CRSTC7,CRSTC8,CRSTC9,CRELC(6)
     * ,CROLC(6),CR131K,CRSTC4,CRSTED(2),CRSYM,CRZER,CRZERM,CRHEAD
     * ,CRLHL,CRIHL,CRRHL,CRDHL,CRCHL, CRFHL,CRLOHL,CRBHL
     * ,CRLBHL(2),CRFEQ,CRPH6,CRB11,CRMSYM,CRPNCH(2)
     * ,CRSDG (2),CRPRAM(3),CRDINT,CRSFL,CRSFNX(4),CRENT,CRIFZ,COMDT(2)
     * ,CRLIBR,CRDBUG,CRUAL,CRCNVT,CRMON,COMFL,SEQNO,CUSFL
     * ,BUG,DMPFLG(2),MAXD,CRREFL,CRSERR,N5RGFB,N5RGFC
     * ,CRTRAC,PARTBZ,COMMAC,COMVER,COMNAM,FEXIT,CROWN,CRNODP
     * ,CRLBCM,U1110A,CREMOT,CRSD1,CRPD1A,CRSTEX,CRAGDG,CRJOPT
     * ,USRAD$,CRSPSU,CR360C,COMVB,EQVTI,FQEHLK,MLINK,MLBHL
     * ,CRLNLB,CRLNAR,CRLNSB,CRLNIF,CRLPLB,RPFOR$(3),CRCRFT,SLCRX(2)
     * ,EPPTR,EPSVI,CRTIME
C
      EQUIVALENCE  (CRLC,CRZER(-1)), (CRBC,CRZERM(-1)), (CRGHL,CRHEAD)
 END
